/** 
 * mhFrame.java
 *
 * Title:			MapHelper
 * Description:		This utility allows us to create maps of differing sizes.
Features Include:
* Placement of terrain
* Placement of obstacles
* Export of pathfinding solution table

 * @author			Administrator
 * @version			
 */


import java.awt.*;
import java.awt.event.*;
import java.io.*;
import net.n3.nanoxml.*;                              

public class mhFrame extends java.awt.Frame implements MouseListener,MouseMotionListener {

// IMPORTANT: Source code between BEGIN/END comment pair will be regenerated
// every time the form is saved. All manual changes will be overwritten.
// BEGIN GENERATED CODE
	// member declarations
	java.awt.Label mStatus = new java.awt.Label();
	java.awt.MenuBar menuBar1 = new java.awt.MenuBar();
	java.awt.Menu menuFile = new java.awt.Menu();
	java.awt.MenuItem menuFileNew = new java.awt.MenuItem();
	java.awt.MenuItem menuFileOpen = new java.awt.MenuItem();
	java.awt.MenuItem menuFileSeparator1 = new java.awt.MenuItem();
	java.awt.MenuItem menuFileSave = new java.awt.MenuItem();
	java.awt.MenuItem menuFileSaveAs = new java.awt.MenuItem();
	java.awt.MenuItem menuFileSeparator2 = new java.awt.MenuItem();
	java.awt.MenuItem menuFileExporttoBMP = new java.awt.MenuItem();
	java.awt.MenuItem menuFileExportHeightMap = new java.awt.MenuItem();
	java.awt.MenuItem menuFileExportTextureMap = new java.awt.MenuItem();
	java.awt.Menu menuView = new java.awt.Menu();
	java.awt.Menu menuViewZoom = new java.awt.Menu();
	java.awt.MenuItem menuViewZoom1x = new java.awt.MenuItem();
	java.awt.MenuItem menuViewZoom2x = new java.awt.MenuItem();
	java.awt.Label mDistanceLabel = new java.awt.Label();
	java.awt.Checkbox mShowGridCheckbox = new java.awt.Checkbox();
	java.awt.Checkbox mShowTerrainTypeCheckbox = new java.awt.Checkbox();
	java.awt.Button mManipulateHeightButton = new java.awt.Button();
	java.awt.Button mManipulateTerrainButton = new java.awt.Button();
	java.awt.Panel mManipulateHeightPanel = new java.awt.Panel();
	java.awt.Choice mHeightChoice = new java.awt.Choice();
	java.awt.Choice mSpreadChoice = new java.awt.Choice();
	java.awt.Label label9 = new java.awt.Label();
	java.awt.Label label10 = new java.awt.Label();
	java.awt.Panel mManipulateTerrainPanel = new java.awt.Panel();
	java.awt.Choice mTileChoice = new java.awt.Choice();
	java.awt.Button mFillButton = new java.awt.Button();
	java.awt.Panel mGeneralPanel = new java.awt.Panel();
	java.awt.Choice mLandscapeChoice = new java.awt.Choice();
	java.awt.TextField mWidthField = new java.awt.TextField();
	java.awt.TextField mHeightField = new java.awt.TextField();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.TextField mXOffsetField = new java.awt.TextField();
	java.awt.TextField mYOffsetField = new java.awt.TextField();
	java.awt.Label label6 = new java.awt.Label();
	java.awt.TextField mPopulationFieldAgrressor = new java.awt.TextField();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.TextField mPopulationFieldDefender = new java.awt.TextField();
	java.awt.Label label5 = new java.awt.Label();
	java.awt.Label label8 = new java.awt.Label();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Button mGeneralButton = new java.awt.Button();
	java.awt.Button mPlaceObjectButton = new java.awt.Button();
	java.awt.Panel mPlaceObjectPanel = new java.awt.Panel();
	java.awt.Label mPropNameLabel = new java.awt.Label();
	java.awt.Choice mObjectChoice = new java.awt.Choice();
	java.awt.Choice mRotationChoice = new java.awt.Choice();
	java.awt.Label mRotationChoiceLabel = new java.awt.Label();
	java.awt.Choice mPropNameChoice = new java.awt.Choice();
	java.awt.Button button1 = new java.awt.Button();
	java.awt.Checkbox mShowPropsChkBox = new java.awt.Checkbox();
	java.awt.Checkbox mShowAltarsChkBox = new java.awt.Checkbox();
// END GENERATED CODE
	int mPanelState;
	final int GENERAL = 0;
	final int MANIPULATE_HEIGHT = 1;
	final int MANIPULATE_TERRAIN = 2;
	final int PLACE_OBJECTS = 3;
	
	mapCanvas mMapCanvas = new mapCanvas();	
	byte mSelectedTileType = 1;
	String mOpenFileName = "";
	boolean mDirty = false;
	
	public mhFrame() 
	{
	}

	public void initComponents() throws Exception {
// IMPORTANT: Source code between BEGIN/END comment pair will be regenerated
// every time the form is saved. All manual changes will be overwritten.
// BEGIN GENERATED CODE
		// the following code sets the frame's initial state
		mStatus.setLocation(new java.awt.Point(10, 520));
		mStatus.setSize(new java.awt.Dimension(480, 20));
		mStatus.setVisible(true);
		menuFile.setLabel("File");
		menuFileNew.setLabel("New");
		menuFileOpen.setActionCommand("n");
		menuFileOpen.setLabel("Open");
		menuFileSeparator1.setLabel("-");
		menuFileSave.setLabel("Save");
		menuFileSaveAs.setLabel("Save As");
		menuFileSeparator2.setLabel("-");
		menuFileExporttoBMP.setLabel("Export to BMP");
		menuFileExportHeightMap.setLabel("Export Height Map");
		menuFileExportTextureMap.setLabel("Export Texture Map");
		menuView.setLabel("View");
		menuViewZoom.setLabel("Zoom");
		menuViewZoom1x.setLabel("1x");
		menuViewZoom2x.setLabel("2x");
		mDistanceLabel.setLocation(new java.awt.Point(10, 550));
		mDistanceLabel.setSize(new java.awt.Dimension(480, 20));
		mDistanceLabel.setVisible(true);
		mShowGridCheckbox.setLabel("show grid");
		mShowGridCheckbox.setLocation(new java.awt.Point(550, 420));
		mShowGridCheckbox.setSize(new java.awt.Dimension(150, 15));
		mShowGridCheckbox.setVisible(true);
		mShowTerrainTypeCheckbox.setLabel("show terrain types");
		mShowTerrainTypeCheckbox.setLocation(new java.awt.Point(550, 440));
		mShowTerrainTypeCheckbox.setSize(new java.awt.Dimension(150, 20));
		mShowTerrainTypeCheckbox.setVisible(true);
		mManipulateHeightButton.setLabel("height map");
		mManipulateHeightButton.setLocation(new java.awt.Point(630, 10));
		mManipulateHeightButton.setSize(new java.awt.Dimension(80, 30));
		mManipulateHeightButton.setVisible(true);
		mManipulateTerrainButton.setLabel("terrain type");
		mManipulateTerrainButton.setLocation(new java.awt.Point(630, 50));
		mManipulateTerrainButton.setSize(new java.awt.Dimension(80, 30));
		mManipulateTerrainButton.setVisible(true);
		mManipulateHeightPanel.setLayout(null);
		mManipulateHeightPanel.setLocation(new java.awt.Point(100, 30));
		mManipulateHeightPanel.setSize(new java.awt.Dimension(170, 180));
		mManipulateHeightPanel.setVisible(false);
		mHeightChoice.setLocation(new java.awt.Point(110, 10));
		mHeightChoice.setSize(new java.awt.Dimension(50, 21));
		mHeightChoice.setVisible(true);
		mSpreadChoice.setLocation(new java.awt.Point(110, 40));
		mSpreadChoice.setSize(new java.awt.Dimension(50, 21));
		mSpreadChoice.setVisible(true);
		label9.setLocation(new java.awt.Point(0, 10));
		label9.setSize(new java.awt.Dimension(90, 20));
		label9.setText("diff height");
		label9.setVisible(true);
		label10.setLocation(new java.awt.Point(0, 40));
		label10.setSize(new java.awt.Dimension(90, 20));
		label10.setText("spread");
		label10.setVisible(true);
		mManipulateTerrainPanel.setLayout(null);
		mManipulateTerrainPanel.setLocation(new java.awt.Point(80, 260));
		mManipulateTerrainPanel.setSize(new java.awt.Dimension(170, 180));
		mManipulateTerrainPanel.setVisible(false);
		mTileChoice.setLocation(new java.awt.Point(0, 10));
		mTileChoice.setSize(new java.awt.Dimension(160, 21));
		mTileChoice.setVisible(true);
		mFillButton.setLabel("Filll with terrain");
		mFillButton.setLocation(new java.awt.Point(0, 50));
		mFillButton.setSize(new java.awt.Dimension(160, 20));
		mFillButton.setVisible(true);
		mGeneralPanel.setLayout(null);
		mGeneralPanel.setLocation(new java.awt.Point(540, 100));
		mGeneralPanel.setSize(new java.awt.Dimension(170, 300));
		mGeneralPanel.setVisible(false);
		mLandscapeChoice.setLocation(new java.awt.Point(0, 30));
		mLandscapeChoice.setSize(new java.awt.Dimension(160, 21));
		mLandscapeChoice.setVisible(true);
		mWidthField.setLocation(new java.awt.Point(0, 79));
		mWidthField.setSize(new java.awt.Dimension(60, 20));
		mWidthField.setText("15");
		mWidthField.setVisible(true);
		mHeightField.setLocation(new java.awt.Point(100, 79));
		mHeightField.setSize(new java.awt.Dimension(60, 20));
		mHeightField.setText("15");
		mHeightField.setVisible(true);
		label3.setLocation(new java.awt.Point(0, 59));
		label3.setSize(new java.awt.Dimension(60, 20));
		label3.setText("width");
		label3.setVisible(true);
		label4.setLocation(new java.awt.Point(100, 59));
		label4.setSize(new java.awt.Dimension(60, 20));
		label4.setText("height");
		label4.setVisible(true);
		mXOffsetField.setLocation(new java.awt.Point(0, 119));
		mXOffsetField.setSize(new java.awt.Dimension(60, 20));
		mXOffsetField.setText("15");
		mXOffsetField.setVisible(true);
		mYOffsetField.setLocation(new java.awt.Point(100, 119));
		mYOffsetField.setSize(new java.awt.Dimension(60, 20));
		mYOffsetField.setText("15");
		mYOffsetField.setVisible(true);
		label6.setLocation(new java.awt.Point(100, 99));
		label6.setSize(new java.awt.Dimension(60, 20));
		label6.setText("y offset");
		label6.setVisible(true);
		mPopulationFieldAgrressor.setLocation(new java.awt.Point(0, 190));
		mPopulationFieldAgrressor.setSize(new java.awt.Dimension(160, 21));
		mPopulationFieldAgrressor.setText("25");
		mPopulationFieldAgrressor.setVisible(true);
		label1.setLocation(new java.awt.Point(0, 100));
		label1.setSize(new java.awt.Dimension(60, 20));
		label1.setText("x offset");
		label1.setVisible(true);
		mPopulationFieldDefender.setLocation(new java.awt.Point(0, 250));
		mPopulationFieldDefender.setSize(new java.awt.Dimension(160, 21));
		mPopulationFieldDefender.setText("25");
		mPopulationFieldDefender.setVisible(true);
		label5.setLocation(new java.awt.Point(0, 160));
		label5.setSize(new java.awt.Dimension(150, 20));
		label5.setText("max troops (aggressor)");
		label5.setVisible(true);
		label8.setLocation(new java.awt.Point(0, 220));
		label8.setSize(new java.awt.Dimension(150, 20));
		label8.setText("max troops (defender)");
		label8.setVisible(true);
		label2.setLocation(new java.awt.Point(0, 0));
		label2.setSize(new java.awt.Dimension(150, 20));
		label2.setText("planet type");
		label2.setVisible(true);
		mGeneralButton.setLabel("general");
		mGeneralButton.setLocation(new java.awt.Point(540, 10));
		mGeneralButton.setSize(new java.awt.Dimension(80, 30));
		mGeneralButton.setVisible(true);
		mPlaceObjectButton.setLabel("place object");
		mPlaceObjectButton.setLocation(new java.awt.Point(540, 50));
		mPlaceObjectButton.setSize(new java.awt.Dimension(80, 30));
		mPlaceObjectButton.setVisible(true);
		mPlaceObjectPanel.setLayout(null);
		mPlaceObjectPanel.setLocation(new java.awt.Point(310, 40));
		mPlaceObjectPanel.setSize(new java.awt.Dimension(170, 210));
		mPlaceObjectPanel.setVisible(false);
		mPropNameLabel.setLocation(new java.awt.Point(0, 60));
		mPropNameLabel.setSize(new java.awt.Dimension(150, 20));
		mPropNameLabel.setText("prop name");
		mPropNameLabel.setVisible(false);
		mObjectChoice.setLocation(new java.awt.Point(0, 10));
		mObjectChoice.setSize(new java.awt.Dimension(160, 21));
		mObjectChoice.setVisible(true);
		mRotationChoice.setLocation(new java.awt.Point(0, 150));
		mRotationChoice.setSize(new java.awt.Dimension(160, 21));
		mRotationChoice.setVisible(false);
		mRotationChoiceLabel.setLocation(new java.awt.Point(0, 120));
		mRotationChoiceLabel.setSize(new java.awt.Dimension(150, 20));
		mRotationChoiceLabel.setText("rotation");
		mRotationChoiceLabel.setVisible(false);
		mPropNameChoice.setLocation(new java.awt.Point(0, 90));
		mPropNameChoice.setSize(new java.awt.Dimension(160, 21));
		mPropNameChoice.setVisible(false);
		button1.setLabel("button1");
		button1.setLocation(new java.awt.Point(560, 560));
		button1.setSize(new java.awt.Dimension(60, 20));
		button1.setVisible(true);
		mShowPropsChkBox.setLabel("show props");
		mShowPropsChkBox.setLocation(new java.awt.Point(550, 460));
		mShowPropsChkBox.setSize(new java.awt.Dimension(140, 20));
		mShowPropsChkBox.setVisible(true);
		mShowAltarsChkBox.setLabel("show altars");
		mShowAltarsChkBox.setLocation(new java.awt.Point(550, 480));
		mShowAltarsChkBox.setSize(new java.awt.Dimension(150, 20));
		mShowAltarsChkBox.setVisible(true);
		setBackground(java.awt.SystemColor.control);
		setLayout(null);
		setLocation(new java.awt.Point(0, 0));
		setMenuBar(menuBar1);
		setTitle("Map Helper");

		menuBar1.add(menuFile);
		menuBar1.add(menuView);
		menuFile.add(menuFileNew);
		menuFile.add(menuFileOpen);
		menuFile.add(menuFileSeparator1);
		menuFile.add(menuFileSave);
		menuFile.add(menuFileSaveAs);
		menuFile.add(menuFileSeparator2);
		menuFile.add(menuFileExporttoBMP);
		menuFile.add(menuFileExportHeightMap);
		menuFile.add(menuFileExportTextureMap);
		menuView.add(menuViewZoom);
		menuViewZoom.add(menuViewZoom1x);
		menuViewZoom.add(menuViewZoom2x);
		mManipulateHeightPanel.add(mHeightChoice);
		mManipulateHeightPanel.add(mSpreadChoice);
		mManipulateHeightPanel.add(label9);
		mManipulateHeightPanel.add(label10);
		mManipulateTerrainPanel.add(mTileChoice);
		mManipulateTerrainPanel.add(mFillButton);
		mGeneralPanel.add(mLandscapeChoice);
		mGeneralPanel.add(mWidthField);
		mGeneralPanel.add(mHeightField);
		mGeneralPanel.add(label3);
		mGeneralPanel.add(label4);
		mGeneralPanel.add(mXOffsetField);
		mGeneralPanel.add(mYOffsetField);
		mGeneralPanel.add(label6);
		mGeneralPanel.add(mPopulationFieldAgrressor);
		mGeneralPanel.add(label1);
		mGeneralPanel.add(mPopulationFieldDefender);
		mGeneralPanel.add(label5);
		mGeneralPanel.add(label8);
		mGeneralPanel.add(label2);
		mPlaceObjectPanel.add(mPropNameLabel);
		mPlaceObjectPanel.add(mObjectChoice);
		mPlaceObjectPanel.add(mRotationChoice);
		mPlaceObjectPanel.add(mRotationChoiceLabel);
		mPlaceObjectPanel.add(mPropNameChoice);
		add(mStatus);
		add(mDistanceLabel);
		add(mShowGridCheckbox);
		add(mShowTerrainTypeCheckbox);
		add(mManipulateHeightButton);
		add(mManipulateTerrainButton);
		add(mManipulateHeightPanel);
		add(mManipulateTerrainPanel);
		add(mGeneralPanel);
		add(mGeneralButton);
		add(mPlaceObjectButton);
		add(mPlaceObjectPanel);
		add(button1);
		add(mShowPropsChkBox);
		add(mShowAltarsChkBox);

		mShowGridCheckbox.setState(true);
		mShowTerrainTypeCheckbox.setState(true);
		mShowPropsChkBox.setState(true);
		mShowAltarsChkBox.setState(true);
		setSize(new java.awt.Dimension(733, 611));

		// event handling
		menuFileNew.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuFileNewActionPerformed(e);
			}
		});
		menuFileOpen.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuFileOpenActionPerformed(e);
			}
		});
		menuFileSave.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuFileSaveActionPerformed(e);
			}
		});
		menuFileSaveAs.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuFileSaveAsActionPerformed(e);
			}
		});
		menuFileExporttoBMP.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuFileExporttoBMPActionPerformed(e);
			}
		});
		menuFileExportHeightMap.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuFileExportHeightMapActionPerformed(e);
			}
		});
		menuFileExportTextureMap.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuFileExportTextureMapActionPerformed(e);
			}
		});
		menuViewZoom1x.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuViewZoom1xActionPerformed(e);
			}
		});
		menuViewZoom2x.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuViewZoom2xActionPerformed(e);
			}
		});
		mShowGridCheckbox.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				mShowGridCheckboxItemStateChanged(e);
			}
		});
		mShowTerrainTypeCheckbox.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				mShowTerrainTypeCheckboxItemStateChanged(e);
			}
		});
		mManipulateHeightButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				mManipulateHeightButtonActionPerformed(e);
			}
		});
		mManipulateTerrainButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				mManipulateTerrainButtonActionPerformed(e);
			}
		});
		mTileChoice.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				mTileChoiceItemStateChanged(e);
			}
		});
		mFillButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				mFillButtonActionPerformed(e);
			}
		});
		mLandscapeChoice.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				mLandscapeChoiceItemStateChanged(e);
			}
		});
		mWidthField.addTextListener(new java.awt.event.TextListener() {
			public void textValueChanged(java.awt.event.TextEvent e) {
				mWidthFieldTextValueChanged(e);
			}
		});
		mHeightField.addTextListener(new java.awt.event.TextListener() {
			public void textValueChanged(java.awt.event.TextEvent e) {
				mHeightFieldTextValueChanged(e);
			}
		});
		mXOffsetField.addTextListener(new java.awt.event.TextListener() {
			public void textValueChanged(java.awt.event.TextEvent e) {
				mXOffsetFieldTextValueChanged(e);
			}
		});
		mYOffsetField.addTextListener(new java.awt.event.TextListener() {
			public void textValueChanged(java.awt.event.TextEvent e) {
				mYOffsetFieldTextValueChanged(e);
			}
		});
		mPopulationFieldAgrressor.addTextListener(new java.awt.event.TextListener() {
			public void textValueChanged(java.awt.event.TextEvent e) {
				mPopulationFieldAgrressorTextValueChanged(e);
			}
		});
		mPopulationFieldDefender.addTextListener(new java.awt.event.TextListener() {
			public void textValueChanged(java.awt.event.TextEvent e) {
				mPopulationFieldDefenderTextValueChanged(e);
			}
		});
		mGeneralButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				mGeneralButtonActionPerformed(e);
			}
		});
		mPlaceObjectButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				mPlaceObjectButtonActionPerformed(e);
			}
		});
		mObjectChoice.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				mObjectChoiceItemStateChanged(e);
			}
		});
		button1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				testXML(e);
			}
		});
		mShowPropsChkBox.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				mShowPropsChkBoxItemStateChanged(e);
			}
		});
		mShowAltarsChkBox.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				mShowAltarsChkBoxItemStateChanged(e);
			}
		});
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				thisWindowClosing(e);
			}
		});

// END GENERATED CODE
		mMapCanvas.setVisible(false);
		mMapCanvas.setLocation(new java.awt.Point(10, 0));
		mMapCanvas.setSize(
							mMapCanvas.mMaxWidth*mMapCanvas.mGridTileSize,
							mMapCanvas.mMaxHeight*mMapCanvas.mGridTileSize);
		add(mMapCanvas);
		mMapCanvas.setVisible(true);
		mMapCanvas.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
		mMapCanvas.addMouseListener(this);
		mMapCanvas.addMouseMotionListener(this);
		mMapCanvas.setMapSize(
					(short)Integer.parseInt(mWidthField.getText()),
					(short)Integer.parseInt(mHeightField.getText())
					);
		mMapCanvas.mOffsetX = (short)Integer.parseInt(mXOffsetField.getText());
		mMapCanvas.mOffsetY = (short)Integer.parseInt(mYOffsetField.getText());
		
		for(int i = 0; i < mMapCanvas.mTerrainTypeStrings.length;i++)
		{
			mTileChoice.add(mMapCanvas.mTerrainTypeStrings[i]);
		}
		mTileChoice.add("Attack Start");
		mTileChoice.add("Defend Start");
		
		mLandscapeChoice.add("altan");
		mLandscapeChoice.add("groth");
		mLandscapeChoice.add("chaar");
		mLandscapeChoice.add("fvost");
		
		mObjectChoice.add("Remove");
		mObjectChoice.add("-");
		mObjectChoice.add("Place Altar");
		mObjectChoice.add("Place Prop");
		
		buildPropList();
		
		mRotationChoice.add("0");
		mRotationChoice.add("90");
		mRotationChoice.add("180");
		mRotationChoice.add("270");
		
		for(int i = 0; i < 17; i++)
		{
			String value = ""+((i-8)>0?"+":"");
			value +=(i-8);
			mHeightChoice.add(value);
		}
		
		for(int i = 1; i < 5; i++)
		{
			String value = ""+i;
			this.mSpreadChoice.add(value);
		}
		
		int panelX, panelY;
		
		panelX = mGeneralPanel.getX();
		panelY = mGeneralPanel.getY();
		
		
		mManipulateHeightPanel.setLocation(panelX,panelY);
		mManipulateTerrainPanel.setLocation(panelX,panelY);
		mPlaceObjectPanel.setLocation(panelX,panelY);
		
		mGeneralPanel.setVisible(true);
		
		
		menuFileNew.setShortcut(new MenuShortcut(KeyEvent.VK_N));
		menuFileOpen.setShortcut(new MenuShortcut(KeyEvent.VK_O));
		menuFileSaveAs.setShortcut(new MenuShortcut(KeyEvent.VK_S,true));
		menuFileSave.setShortcut(new MenuShortcut(KeyEvent.VK_S));
		menuViewZoom1x.setShortcut(new MenuShortcut(KeyEvent.VK_MINUS));
		menuViewZoom2x.setShortcut(new MenuShortcut(KeyEvent.VK_EQUALS));
		
		//add file menu stuff
		/*javax.swing.JMenu fileMenu = new javax.swing.JMenu("File");
		fileMenu.add("New");
		fileMenu.add("Open");
		fileMenu.add("Save");
		fileMenu.add("Export to BMP");
		jMenuBar1.add(fileMenu);*/
		//mMapCanvas.primeImages();
	}
  
  	private boolean mShown = false;
	
	public void setStatus(String s)
	{
		mStatus.setText("STATUS:"+s);
	
	}
  	
	public void addNotify() {
		super.addNotify();
		
		if (mShown)
			return;
			
		// move components to account for insets
		Insets insets = getInsets();
		Component[] components = getComponents();
		for (int i = 0; i < components.length; i++) {
			Point location = components[i].getLocation();
			location.move(location.x, location.y + insets.top);
			components[i].setLocation(location);
		}

		mShown = true;
	}

	// Close the window when the close box is clicked
	void thisWindowClosing(java.awt.event.WindowEvent e) {
		setVisible(false);
		dispose();
		System.exit(0);
	}
	
	public void mouseEntered(MouseEvent e) 
	{
		System.out.println("mouse entered");;
	}
	public void mouseExited(MouseEvent e) {;}
	public void mousePressed(MouseEvent e) {;}
	public void mouseReleased(MouseEvent e) {;} 
	public void mouseMoved(MouseEvent e) 
	{
		int x = e.getX()/mMapCanvas.mGridTileSize;
		int y = e.getY()/mMapCanvas.mGridTileSize;
		String statusString = "x:"+x+" y:"+y;
		statusString += " height="+mMapCanvas.mTileHeights[x][y];
		if(x >= mMapCanvas.mOffsetX && x < mMapCanvas.mOffsetX +mMapCanvas.mWidth && y >= mMapCanvas.mOffsetY && y < mMapCanvas.mOffsetY + mMapCanvas.mHeight)
		{
		/*	if(this.mTestPathCheckBox.getState())
			{
					mMapCanvas.paint(mMapCanvas.getGraphics());
					int cost = mMapCanvas.paintPath(Integer.parseInt(mStartXField.getText()),
								Integer.parseInt(mStartYField.getText()),
								x,
								y);
					mDistanceLabel.setText(""+cost);	
			}*/
			statusString+=" "+mMapCanvas.mTerrainTypeStrings[mMapCanvas.mTiles[x][y]-1];
		}
		if(mMapCanvas.mProps[x][y] != null)
			statusString+=" prop = "+mMapCanvas.mProps[x][y]+" rot = "+mMapCanvas.mRotations[x][y];
		this.setStatus(statusString);
	} 
           
	public void mouseDragged(MouseEvent e) 
	{
		int x = e.getX()/mMapCanvas.mGridTileSize;
		int y = e.getY()/mMapCanvas.mGridTileSize;
		if(x >= 0 && x < mMapCanvas.mMaxWidth && y >= 0 && y < mMapCanvas.mMaxHeight)
		{
			if(mManipulateTerrainPanel.isVisible())
			{
				if(mSelectedTileType <= mMapCanvas.mTerrainTypeStrings.length)
					mMapCanvas.setTile(x,y,mSelectedTileType);
				else
				{
					mMapCanvas.setStartPoint(x,y,mSelectedTileType - mMapCanvas.mTerrainTypeStrings.length);
				} 
				setDirty();
			}
		}
	} 

	public void mouseClicked(MouseEvent e)
	{
		int x = e.getX()/mMapCanvas.mGridTileSize;
		int y = e.getY()/mMapCanvas.mGridTileSize;
		if(x >= 0 && x < mMapCanvas.mMaxWidth && y >= 0 && y < mMapCanvas.mMaxHeight)
		{
			/*if(this.mTestPathCheckBox.getState())
			{
				this.mStartXField.setText(""+x);
				this.mStartYField.setText(""+y);
				
			}
			else*/
			{
				/*if(this.mManipulateHeightCheckBox.getState())*/
				if(mPanelState == this.MANIPULATE_HEIGHT)
				{
					int spread = mSpreadChoice.getSelectedIndex()+1;
					int height = mHeightChoice.getSelectedIndex()-8;
					mMapCanvas.setHeight(x,y,height,spread);
					mMapCanvas.paintArea(mMapCanvas.getGraphics(),
								x-spread,y-spread,
								spread*2+1,spread*2+1);
				}
				else if(mPanelState == this.MANIPULATE_TERRAIN)
				{
					if(mSelectedTileType <= mMapCanvas.mTerrainTypeStrings.length)
						mMapCanvas.setTile(x,y,mSelectedTileType);
					else
					{
						mMapCanvas.setStartPoint(x,y,mSelectedTileType - mMapCanvas.mTerrainTypeStrings.length);
					} 
				}
				else if(mPanelState == this.PLACE_OBJECTS)
				{
					placeObject(x,y);
				}
				setDirty();
			}
			
		}
		
	}
	public void placeObject(int x, int y)
	{
		int race = mMapCanvas.mCurrentPlanetType;
		if(this.mObjectChoice.getSelectedItem().equals("Place Altar"))
		{
			mMapCanvas.setObject(x,y,race + mMapCanvas.LIGHT_ALTAR,race,2);
		}
		else if(this.mObjectChoice.getSelectedItem().equals("Place Prop"))
		{
			mMapCanvas.setProp(x,y,mPropNameChoice.getSelectedItem(),Integer.parseInt(mRotationChoice.getSelectedItem()));
		}
		else if(this.mObjectChoice.getSelectedItem().equals("Remove"))
		{
			mMapCanvas.setObject(x,y,0,0,0);
			mMapCanvas.setProp(x,y,"",0);
		}
	
	
	}
	public void mTileChoiceItemStateChanged(java.awt.event.ItemEvent e) 
	{
		mSelectedTileType = (byte)(mTileChoice.getSelectedIndex()+1);
	}
	
	public void mObjectChoiceItemStateChanged(java.awt.event.ItemEvent e) 
	{
		if(mObjectChoice.getSelectedItem().equals("Place Prop"))
		{
			mPropNameChoice.setVisible(true);
			mPropNameLabel.setVisible(true);
			mRotationChoice.setVisible(true);
			mRotationChoiceLabel.setVisible(true);
		}
		else
		{
			mPropNameChoice.setVisible(false);
			mPropNameLabel.setVisible(false);
			mRotationChoice.setVisible(false);
			mRotationChoiceLabel.setVisible(false);
		}
		
	}
	
	public void mWidthFieldTextValueChanged(java.awt.event.TextEvent e) 
	{
		
		mMapCanvas.setMapSize(
				(short)Integer.parseInt(mWidthField.getText()),
				(short)Integer.parseInt(mHeightField.getText())
				);
		String s = e.paramString();
		
		//a bit of a hack but i don't know of any other way for 
		//it not to mark the file dirty
		if(mWidthField.isEnabled())
			setDirty();
		else
			mWidthField.enable();
	}
	
	public void mHeightFieldTextValueChanged(java.awt.event.TextEvent e) 
	{
		mMapCanvas.setMapSize(
					(short)Integer.parseInt(mWidthField.getText()),
					(short)Integer.parseInt(mHeightField.getText())
					);
		//a bit of a hack but i don't know of any other way for 
		//it not to mark the file dirty
		if(mHeightField.isEnabled())
			setDirty();
		else
			mHeightField.enable();
	}
	public void mXOffsetFieldTextValueChanged(java.awt.event.TextEvent e) 
	{
		mMapCanvas.mOffsetX = (short)Integer.parseInt(mXOffsetField.getText());
		//a bit of a hack but i don't know of any other way for 
		//it not to mark the file dirty
		if(mXOffsetField.isEnabled())
			setDirty();
		else
			mXOffsetField.enable();
		mMapCanvas.repaint();
	}
	public void mYOffsetFieldTextValueChanged(java.awt.event.TextEvent e) 
	{
		mMapCanvas.mOffsetY = (short)Integer.parseInt(mYOffsetField.getText());
		
		//a bit of a hack but i don't know of any other way for 
		//it not to mark the file dirty
		if(mYOffsetField.isEnabled())
			setDirty();
		else
			mYOffsetField.enable();
		mMapCanvas.repaint();
	}
	
	public void menuViewZoom1xActionPerformed(java.awt.event.ActionEvent e) 
	{
		mMapCanvas.setZoom(1);
		mMapCanvas.resize(mMapCanvas.mMaxWidth*mMapCanvas.mGridTileSize, mMapCanvas.mMaxHeight*mMapCanvas.mGridTileSize);
	}
	
	public void menuViewZoom2xActionPerformed(java.awt.event.ActionEvent e) 
	{
		mMapCanvas.setZoom(2);
		mMapCanvas.resize(mMapCanvas.mMaxWidth*mMapCanvas.mGridTileSize, mMapCanvas.mMaxHeight*mMapCanvas.mGridTileSize);
	}
	class smfFilter implements FilenameFilter
	{
		public boolean accept(File dir, String name) 
		{
			if(name.endsWith("smf"))
				return true;
			else
				return false;
		}
	}
	public void menuFileSaveActionPerformed(java.awt.event.ActionEvent e) 
	{
		if(mOpenFileName.equals(""))
			saveAsFile();
		else
			saveFile(mOpenFileName);
			
		//setStatus(filename+" saved");
	}
	public void menuFileSaveAsActionPerformed(java.awt.event.ActionEvent e) 
	{
		saveAsFile();
	}
	public void saveAsFile()
	{
		FileDialog d = new  FileDialog(this, "Save .smf", FileDialog.SAVE);
		d.setFilenameFilter(new smfFilter());
		d.setFile("*.smf");
		d.show();
		String fileName = d.getFile();
		if(fileName != null)
		{
			//do a little string manipulation to get the suffix
			// in and lower case
			if(fileName.toLowerCase().endsWith(".smf"))
			{
				int index = fileName.lastIndexOf('.');
				String suffix = fileName.substring(index);
				suffix = suffix.toLowerCase();
				String prefix = fileName.substring(0,index);
				fileName = prefix+suffix;
			}
			else
			{
				fileName += ".smf";
			}
			
			saveFile(d.getDirectory()+fileName);
		}
	}
	public void saveFile(String fileName)
	{
		setStatus("saving "+fileName);
		try
		{
			FileOutputStream fout = new FileOutputStream(fileName);
			DataOutputStream out = new DataOutputStream(fout); 
			mMapCanvas.save(out);
			fout.close();
			setClean(fileName);
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
			mOpenFileName = "";
			setNew();
		}	
		setStatus(fileName+" saved");	
	}
	public void setClean(String fileName)
	{
		String s = fileName.substring(fileName.lastIndexOf('\\')+1);
		String title = "Map Helper ";
		title+=s;
		setTitle(title);
		mOpenFileName = fileName;
		mDirty = false;
	}
	public void setDirty()
	{
		if(!mDirty)
		{
			String title = this.getTitle();
			title+="*";
			setTitle(title);
			mDirty = true;
		}
	}
	public void setNew()
	{
		mOpenFileName = "";
		setTitle("Map Helper ");
		mDirty = false;
	}	
	public void menuFileOpenActionPerformed(java.awt.event.ActionEvent e) 
	{
		FileDialog d = new  FileDialog(this, "Open an smf file", FileDialog.LOAD);
		d.setFilenameFilter(new smfFilter());
		d.setFile("*.smf");
		d.show();
		String fileName = d.getFile();
		if(fileName != null)
		{
			System.out.println("saving: "+d.getDirectory()+fileName);
			try
			{
				FileInputStream fin = new FileInputStream(d.getDirectory()+fileName);
				DataInputStream in = new DataInputStream(fin); 
				
				mMapCanvas.clearHeights(8);
				mMapCanvas.clearProps();
				mMapCanvas.clearObjects();
				mMapCanvas.read(in);
				fin.close();
				//reset the text fields
				
				//a bit of a hack we will disable these guys
				//so that they know to not "setDirty()"
				mWidthField.disable();
				mHeightField.disable();
				mXOffsetField.disable();
				mYOffsetField.disable();
				this.mPopulationFieldAgrressor.disable();
				this.mPopulationFieldDefender.disable();
				//this.mExportPathTableCheckbox.disable();
				
				mWidthField.setText(""+mMapCanvas.mWidth);
				mHeightField.setText(""+mMapCanvas.mHeight);
				mXOffsetField.setText(""+mMapCanvas.mOffsetX);
				mYOffsetField.setText(""+mMapCanvas.mOffsetY);
				
				mPopulationFieldAgrressor.setText(""+mMapCanvas.mMaxTroopsAggressor);
				mPopulationFieldDefender.setText(""+mMapCanvas.mMaxTroopsDefender);
				
				//mExportPathTableCheckbox.setState(mMapCanvas.mExportPaths);
				//mExportPathTableCheckbox.enable();
				
				mPopulationFieldAgrressor.enable();
				mPopulationFieldDefender.enable();
				
				setClean(d.getDirectory()+fileName);
			}
			catch(Exception ex)
			{
				ex.printStackTrace();
			}
		}
	}
	public void menuFileExporttoBMPActionPerformed(java.awt.event.ActionEvent e) 
	{
		FileDialog d = new  FileDialog(this, "where's the bmp", FileDialog.SAVE);
		//d.setFilenameFilter(new smfFilter());
		String f;
		
		if(mOpenFileName.equals(""))
			f = "*.bmp";
		else
		{
			f = mOpenFileName.substring(mOpenFileName.lastIndexOf('\\')+1);
			f = f.substring(0,f.lastIndexOf(".smf"));
			f = f+".bmp";
		}
		d.setFile(f);
		d.show();
		String fileName = d.getFile();
		if(fileName != null)
		{
			setStatus("saving: "+d.getDirectory()+fileName);
			try
			{
				FileOutputStream fout = new FileOutputStream(d.getDirectory()+fileName);
				DataOutputStream out = new DataOutputStream(fout); 
				mMapCanvas.exportBMP(out,mMapCanvas.EXPORT_NORMAL);
				fout.close();
			}
			catch(Exception ex)
			{
				ex.printStackTrace();
			}
			setStatus("file saved");
		}
	}
	public void menuFileExportHeightMapActionPerformed(java.awt.event.ActionEvent e) 
	{
		FileDialog d = new  FileDialog(this, "where's the bmp", FileDialog.SAVE);
		//d.setFilenameFilter(new smfFilter());
		String f;
		
		if(mOpenFileName.equals(""))
			f = "*.bmp";
		else
		{
			f = mOpenFileName.substring(mOpenFileName.lastIndexOf('\\')+1);
			f = f.substring(0,f.lastIndexOf(".smf"));
			f = f+"_height.bmp";
		}
		d.setFile(f);
		d.show();
		String fileName = d.getFile();
		if(fileName != null)
		{
			setStatus("saving: "+d.getDirectory()+fileName);
			FileOutputStream fout = null;
			try
			{
				fout = new FileOutputStream(d.getDirectory()+fileName);
				DataOutputStream out = new DataOutputStream(fout); 
				mMapCanvas.exportBMP(out,mMapCanvas.EXPORT_HEIGHT);
				fout.close();
			}
			catch(Exception ex)
			{
				ex.printStackTrace();
			}
				
			setStatus("file saved");
		}
	
	}
		
	public void menuFileExportTextureMapActionPerformed(java.awt.event.ActionEvent e) 
	{

		FileDialog d = new  FileDialog(this, "where's the bmp", FileDialog.SAVE);
		//d.setFilenameFilter(new smfFilter());
		String f;
		
		if(mOpenFileName.equals(""))
			f = "*.bmp";
		else
		{
			f = mOpenFileName.substring(mOpenFileName.lastIndexOf('\\')+1);
			f = f.substring(0,f.lastIndexOf(".smf"));
			f = f+"_texture.bmp";
		}
		d.setFile(f);
		d.show();
		String fileName = d.getFile();
		if(fileName != null)
		{
			setStatus("saving: "+d.getDirectory()+fileName);
			try
			{
				FileOutputStream fout = new FileOutputStream(d.getDirectory()+fileName);
				DataOutputStream out = new DataOutputStream(fout); 
				mMapCanvas.exportBMP(out,mMapCanvas.EXPORT_TEXTURE);
				fout.close();
			}
			catch(Exception ex)
			{
				ex.printStackTrace();
			}
			setStatus("file saved");
		}

	}
	public void mCreateSolutionButtonActionPerformed(java.awt.event.ActionEvent e) 
	{
		mMapCanvas.createSolutionTable();
	}
	
	public void menuFileNewActionPerformed(java.awt.event.ActionEvent e) 
	{
		mWidthField.disable();
		mHeightField.disable();
		mXOffsetField.disable();
		mYOffsetField.disable();

		mWidthField.setText("15");
		mHeightField.setText("15");
		mXOffsetField.setText("15");
		mYOffsetField.setText("15");
		
		mMapCanvas.clear(mMapCanvas.TERRAIN_NORMAL);
		mMapCanvas.clearHeights(8);
		mMapCanvas.clearProps();
		mMapCanvas.clearObjects();
		setNew();
	
	}
	
	public void mFillButtonActionPerformed(java.awt.event.ActionEvent e) 
	{
		if(mSelectedTileType <= mMapCanvas.mTerrainTypeStrings.length)
			mMapCanvas.clear((byte)this.mSelectedTileType);
		mMapCanvas.repaint();
	}
	
	public void mPopulationFieldDefenderTextValueChanged(java.awt.event.TextEvent e) 
	{
		mMapCanvas.mMaxTroopsDefender = (short)Integer.parseInt(mPopulationFieldDefender.getText());
	}
	
	public void mPopulationFieldAgrressorTextValueChanged(java.awt.event.TextEvent e) 
	{
		mMapCanvas.mMaxTroopsAggressor = (short)Integer.parseInt(mPopulationFieldAgrressor.getText());

	}
	/*
	public void mExportPathTableCheckboxItemStateChanged(java.awt.event.ItemEvent e) 
	{
		mMapCanvas.mExportPaths = mExportPathTableCheckbox.getState();
	}*/
	
	public void mShowGridCheckboxItemStateChanged(java.awt.event.ItemEvent e) 
	{
		mMapCanvas.mShowGrid =  mShowGridCheckbox.getState();
		mMapCanvas.repaint();
	}
	
	public void mManipulateHeightCheckBoxItemStateChanged(java.awt.event.ItemEvent e) 
	{
		/*boolean state = mManipulateHeightCheckBox.getState();
		if(state == true)
		{
			mHeightChoice.enable();
			mSpreadChoice.enable();
			mTileChoice.disable();
			mFillButton.disable();
			mShowTerrainTypeCheckbox.setState(false);
			mMapCanvas.mShowTerrainType=false;
			mShowTerrainTypeCheckbox.enable();
		}
		else
		{
			mHeightChoice.disable();
			mSpreadChoice.disable();
			mTileChoice.enable();
			mFillButton.enable();
			mShowTerrainTypeCheckbox.setState(true);
			mMapCanvas.mShowTerrainType=true;
			mShowTerrainTypeCheckbox.disable();
		}
		mMapCanvas.repaint();*/
	}
	
	public void mShowTerrainTypeCheckboxItemStateChanged(java.awt.event.ItemEvent e) 
	{
		mMapCanvas.mShowTerrainType = mShowTerrainTypeCheckbox.getState();
		mMapCanvas.repaint();
	}
	
	public void mLandscapeChoiceItemStateChanged(java.awt.event.ItemEvent e) 
	{
			mMapCanvas.changeTerrainImages(mLandscapeChoice.getSelectedItem());
			mMapCanvas.mCurrentPlanetType = mLandscapeChoice.getSelectedIndex();
	}
		
	public void mGeneralButtonActionPerformed(java.awt.event.ActionEvent e) 
	{
		mPanelState = GENERAL;
		mGeneralPanel.setVisible(true);
		mManipulateHeightPanel.setVisible(false);
		mManipulateTerrainPanel.setVisible(false);
		mPlaceObjectPanel.setVisible(false);
	}
	
	public void mManipulateHeightButtonActionPerformed(java.awt.event.ActionEvent e) 
	{
		mPanelState = MANIPULATE_HEIGHT;
		mGeneralPanel.setVisible(false);
		mManipulateHeightPanel.setVisible(true);
		mManipulateTerrainPanel.setVisible(false);
		mPlaceObjectPanel.setVisible(false);

	}
	
	public void mManipulateTerrainButtonActionPerformed(java.awt.event.ActionEvent e) 
	{
		mPanelState = MANIPULATE_TERRAIN;
		mGeneralPanel.setVisible(false);
		mManipulateHeightPanel.setVisible(false);
		mManipulateTerrainPanel.setVisible(true);
		mPlaceObjectPanel.setVisible(false);

	}
	
	public void mPlaceObjectButtonActionPerformed(java.awt.event.ActionEvent e) 
	{
		mPanelState = PLACE_OBJECTS;
		mGeneralPanel.setVisible(false);
		mManipulateHeightPanel.setVisible(false);
		mManipulateTerrainPanel.setVisible(false);
		mPlaceObjectPanel.setVisible(true);
	}
	
	public void buildPropList()
	{
		File f = new File("../../media/props/");
		String[] files = f.list( 
			new FilenameFilter()
			{
				public boolean accept(File dir, String name)
				{
					if(name.endsWith("xml"))
						return true;
					else
						return false;
				}
			
			}
			
			);
		for(int i = 0; i < files.length; i++)
			this.mPropNameChoice.add(files[i]); 
	}							

	public void testXML(java.awt.event.ActionEvent e) 
	{
		File f = new File("../../media/props/");
		String[] files = f.list( 
			new FilenameFilter()
			{
				public boolean accept(File dir, String name)
				{
					if(name.endsWith("xml"))
						return true;
					else
						return false;
				}
			
			}
			
			);
		for(int i = 0; i < files.length; i++)
			System.out.println(files[i]);
		try
		{
			IXMLParser parser = XMLParserFactory.createDefaultXMLParser();
			IXMLReader reader = StdXMLReader.fileReader("../../media/props/altantree.xml");
			parser.setReader(reader);
			IXMLElement xml = (IXMLElement) parser.parse();
			java.util.Vector v = xml.getChildrenNamed("size");
			if(v.size() > 0)
			{
				IXMLElement size = (IXMLElement)v.firstElement();
				int h = Integer.parseInt(size.getAttribute("height"));
				int w = Integer.parseInt(size.getAttribute("width"));
				System.out.println("height ="+h+" width= "+w);
			}
			else
			{
			
			}
			//XMLWriter writer = new XMLWriter(System.out);
			//writer.write(xml);
		}catch(Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	public void mShowPropsChkBoxItemStateChanged(java.awt.event.ItemEvent e) 
	{
		mMapCanvas.mShowProps = mShowPropsChkBox.getState();
		mMapCanvas.repaint();
	}
	
	public void mShowAltarsChkBoxItemStateChanged(java.awt.event.ItemEvent e) 
	{
		mMapCanvas.mShowAltars = mShowAltarsChkBox.getState();
		mMapCanvas.repaint();
	}
		
		
										
		
					
		
									  					
}
