/** 
 * smFrame.java
 *
 * Title:			Space Map Editor
 * Description:		The space editor for supremacy this utility allows the designer
to create different space maps and have different starting
scripts based on who the CO is.
 * @author			nik
 * @version			
 */


import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

public class smFrame extends java.awt.Frame implements MouseListener, MouseMotionListener {
boolean mDirty = false;
String mOpenFileName = "";

String mGroundUnitColumns[] = {"unit types","quantity","special"};
Object mGroundUnitData[][] ={
		{"UNDEAD","0","0"},					//1
		{"RANGED","0","0"},					//2
		{"GRUNT","0","0"},					//3
		{"MORTAR_MAN","0","0"},				//4
		{"MORTAR_SIEGE","0","0"},			//5
		{"LARGE_TANK","0","0"},				//6
		{"SIEGE_TANK","0","0"},				//7
		{"LIGHT_MECH","0","0"},				//8
		{"SWAMP_MECH","0","0"},				//9
		{"FIRE_MECH","0","0"},				//10
		{"ICE_MECH","0","0"},				//11
		{"LIGHT_SPECIAL","0","0"},			//12
		{"SWAMP_SPECIAL","0","0"},			//13
		{"FIRE_SPECIAL","0","0"},			//14
		{"ICE_SPECIAL","0","0"},			//15
		{"LIGHT_FORCEFIELD","0","0"},		//16
		{"SWAMP_FORCEFIELD","0","0"},		//17
		{"FIRE_FORCEFIELD","0","0"},		//18
		{"ICE_FORCEFIELD","0","0"},			//19
		{"LIGHT_FORCEFIELD_A","0","0"},		//20
		{"SWAMP_FORCEFIELD_A","0","0"},		//21
		{"FIRE_FORCEFIELD_A","0","0"},		//22
		{"ICE_FORCEFIELD_A","0","0"}		//23                       
		};								
Object mPlayerResourceData[][] = 
	{
		{"Player0","200","100","100","100","100"},
		{"Player1","200","100","100","100","100"}
	};
String mPlayerResourceColumns[] = 
	{
		"Player",
		"Gold",
		"Ore",
		"Crystals",
		"Fuel",
		"Food"
	};
// IMPORTANT: Source code between BEGIN/END comment pair will be regenerated
// every time the form is saved. All manual changes will be overwritten.
// BEGIN GENERATED CODE
	// member declarations
	java.awt.Choice mTypeChoice = new java.awt.Choice();
	java.awt.Choice mSpecificsChoice1 = new java.awt.Choice();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Label mPlayer0Label = new java.awt.Label();
	java.awt.Label mPlayer1Label = new java.awt.Label();
	java.awt.Choice mPlayerChoice = new java.awt.Choice();
	java.awt.TextField mFilenameField = new java.awt.TextField();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.TextField mPlanetNameField = new java.awt.TextField();
	java.awt.Button mSubmitButton = new java.awt.Button();
	java.awt.Label mDistanceLabel = new java.awt.Label();
	javax.swing.JTable jTable1 = new javax.swing.JTable();
	javax.swing.JScrollPane jScrollPane1 = new javax.swing.JScrollPane();
	javax.swing.JTable jTable2 = new javax.swing.JTable();
	java.awt.MenuBar menuBar1 = new java.awt.MenuBar();
	java.awt.Menu menuFile = new java.awt.Menu();
	java.awt.MenuItem menuFileNew = new java.awt.MenuItem();
	java.awt.MenuItem menuFileOpen = new java.awt.MenuItem();
	java.awt.MenuItem menuFileSave = new java.awt.MenuItem();
	java.awt.MenuItem menuFileSaveAs = new java.awt.MenuItem();
	java.awt.MenuItem menuFileSavePreviewBMP = new java.awt.MenuItem();
	java.awt.MenuItem menuFileExit = new java.awt.MenuItem();
	java.awt.Menu menuEdit = new java.awt.Menu();
	java.awt.MenuItem menuEditCut = new java.awt.MenuItem();
	java.awt.MenuItem menuEditCopy = new java.awt.MenuItem();
	java.awt.MenuItem menuEditPaste = new java.awt.MenuItem();
	java.awt.Menu menuOptions = new java.awt.Menu();
	java.awt.CheckboxMenuItem menuOptionsSinglePlayer = new java.awt.CheckboxMenuItem();
	java.awt.CheckboxMenuItem menuOptionsMultiPlayer = new java.awt.CheckboxMenuItem();
	java.awt.MenuItem menuOptionsSeparator1 = new java.awt.MenuItem();
	java.awt.Menu menuOptionsGameType = new java.awt.Menu();
	java.awt.CheckboxMenuItem menuOptionsGameTypeCaptureAllPlanets = new java.awt.CheckboxMenuItem();
	java.awt.CheckboxMenuItem menuOptionsGameTypeCaptureAllStations = new java.awt.CheckboxMenuItem();
	java.awt.CheckboxMenuItem menuOptionsGameTypeRescueMission = new java.awt.CheckboxMenuItem();
	java.awt.CheckboxMenuItem menuOptionsGameTypeEscortMission = new java.awt.CheckboxMenuItem();
	java.awt.CheckboxMenuItem menuOptionsGameTypeSoccer = new java.awt.CheckboxMenuItem();
	java.awt.CheckboxMenuItem menuOptionsGameTypeHoldDowntheFort = new java.awt.CheckboxMenuItem();
	java.awt.Checkbox mSpecialCheckbox = new java.awt.Checkbox();
	java.awt.TextField mNumTurnsText = new java.awt.TextField();
	java.awt.Label label5 = new java.awt.Label();
	java.awt.TextField mTimePerTurnText = new java.awt.TextField();
	java.awt.Label label6 = new java.awt.Label();
	java.awt.Checkbox mSpecialInsideCheckbox = new java.awt.Checkbox();
// END GENERATED CODE

	smCanvas mCanvas;
	smPickerCanvas mPicker;
	
	public smFrame() 
	{
		jTable1 = new javax.swing.JTable(mGroundUnitData, mGroundUnitColumns);
		jTable2 = new javax.swing.JTable(mPlayerResourceData, mPlayerResourceColumns);
	}

	public void initComponents() throws Exception {
// IMPORTANT: Source code between BEGIN/END comment pair will be regenerated
// every time the form is saved. All manual changes will be overwritten.
// BEGIN GENERATED CODE
		// the following code sets the frame's initial state
		mTypeChoice.setVisible(true);
		mTypeChoice.setLocation(new java.awt.Point(810, 220));
		mTypeChoice.setSize(new java.awt.Dimension(130, 21));
		mSpecificsChoice1.setVisible(true);
		mSpecificsChoice1.setEnabled(false);
		mSpecificsChoice1.setLocation(new java.awt.Point(950, 220));
		mSpecificsChoice1.setSize(new java.awt.Dimension(130, 21));
		label1.setVisible(true);
		label1.setLocation(new java.awt.Point(810, 200));
		label1.setText("type of unit");
		label1.setSize(new java.awt.Dimension(130, 20));
		label2.setVisible(true);
		label2.setLocation(new java.awt.Point(950, 200));
		label2.setSize(new java.awt.Dimension(130, 20));
		mPlayer0Label.setBackground(java.awt.Color.magenta);
		mPlayer0Label.setVisible(true);
		mPlayer0Label.setLocation(new java.awt.Point(950, 30));
		mPlayer0Label.setText("PLAYER 0");
		mPlayer0Label.setSize(new java.awt.Dimension(130, 20));
		mPlayer1Label.setBackground(java.awt.Color.green);
		mPlayer1Label.setVisible(true);
		mPlayer1Label.setLocation(new java.awt.Point(950, 50));
		mPlayer1Label.setText("PLAYER 1");
		mPlayer1Label.setSize(new java.awt.Dimension(130, 20));
		mPlayerChoice.setVisible(true);
		mPlayerChoice.setLocation(new java.awt.Point(950, 0));
		mPlayerChoice.setSize(new java.awt.Dimension(130, 21));
		mFilenameField.setLocation(new java.awt.Point(810, 270));
		mFilenameField.setVisible(true);
		mFilenameField.setSize(new java.awt.Dimension(130, 20));
		label3.setVisible(true);
		label3.setLocation(new java.awt.Point(810, 250));
		label3.setText("filename");
		label3.setSize(new java.awt.Dimension(130, 20));
		label4.setVisible(true);
		label4.setLocation(new java.awt.Point(950, 250));
		label4.setText("planet name");
		label4.setSize(new java.awt.Dimension(130, 20));
		mPlanetNameField.setLocation(new java.awt.Point(950, 270));
		mPlanetNameField.setVisible(true);
		mPlanetNameField.setSize(new java.awt.Dimension(130, 20));
		mSubmitButton.setVisible(true);
		mSubmitButton.setLabel("Update");
		mSubmitButton.setLocation(new java.awt.Point(810, 710));
		mSubmitButton.setSize(new java.awt.Dimension(130, 30));
		mDistanceLabel.setVisible(true);
		mDistanceLabel.setLocation(new java.awt.Point(960, 710));
		mDistanceLabel.setText("distance:");
		mDistanceLabel.setSize(new java.awt.Dimension(120, 20));
		jTable1.setVisible(true);
		jTable1.setSize(new java.awt.Dimension(270, 370));
		jTable1.setLocation(new java.awt.Point(810, 330));
		jScrollPane1.setSize(new java.awt.Dimension(270, 52));
		jScrollPane1.setLocation(new java.awt.Point(810, 140));
		jScrollPane1.setVisible(true);
		jTable2.setVisible(true);
		menuFile.setLabel("File");
		menuFileNew.setLabel("New");
		menuFileOpen.setLabel("Open");
		menuFileSave.setLabel("Save");
		menuFileSaveAs.setLabel("SaveAs");
		menuFileSavePreviewBMP.setLabel("ExportPreviewBMP");
		menuFileExit.setLabel("Exit");
		menuEdit.setLabel("Edit");
		menuEditCut.setLabel("Cut");
		menuEditCopy.setLabel("Copy");
		menuEditPaste.setLabel("Paste");
		menuOptions.setLabel("Options");
		menuOptionsSinglePlayer.setState(true);
		menuOptionsSinglePlayer.setLabel("Single Player");
		menuOptionsMultiPlayer.setLabel("Multi Player");
		menuOptionsSeparator1.setLabel("-");
		menuOptionsGameType.setLabel("Game Type");
		menuOptionsGameTypeCaptureAllPlanets.setState(true);
		menuOptionsGameTypeCaptureAllPlanets.setLabel("Conquest");
		menuOptionsGameTypeCaptureAllStations.setLabel("Rescue Hero");
		menuOptionsGameTypeRescueMission.setLabel("Protect Home Planet");
		menuOptionsGameTypeEscortMission.setLabel("King of the Station");
		menuOptionsGameTypeSoccer.setLabel("Capture Home World");
		menuOptionsGameTypeHoldDowntheFort.setLabel("Body Count");
		mSpecialCheckbox.setVisible(true);
		mSpecialCheckbox.setLabel("Mark Special");
		mSpecialCheckbox.setLocation(new java.awt.Point(810, 300));
		mSpecialCheckbox.setSize(new java.awt.Dimension(90, 20));
		mNumTurnsText.setLocation(new java.awt.Point(920, 80));
		mNumTurnsText.setVisible(true);
		mNumTurnsText.setText("-1");
		mNumTurnsText.setSize(new java.awt.Dimension(50, 20));
		label5.setVisible(true);
		label5.setLocation(new java.awt.Point(810, 110));
		label5.setText("Time Per Turn");
		label5.setSize(new java.awt.Dimension(80, 20));
		mTimePerTurnText.setLocation(new java.awt.Point(920, 110));
		mTimePerTurnText.setVisible(true);
		mTimePerTurnText.setText("-1");
		mTimePerTurnText.setSize(new java.awt.Dimension(50, 20));
		label6.setVisible(true);
		label6.setLocation(new java.awt.Point(810, 80));
		label6.setText("No. of Turns");
		label6.setSize(new java.awt.Dimension(80, 20));
		mSpecialInsideCheckbox.setVisible(true);
		mSpecialInsideCheckbox.setLabel("generate special subunit");
		mSpecialInsideCheckbox.setLocation(new java.awt.Point(920, 300));
		mSpecialInsideCheckbox.setSize(new java.awt.Dimension(160, 20));
		setLocation(new java.awt.Point(0, 0));
		setLayout(null);
		setTitle("smFrame");
		setBackground(java.awt.SystemColor.control);
		setMenuBar(menuBar1);

		jScrollPane1.getViewport().add(jTable2);
		menuBar1.add(menuFile);
		menuBar1.add(menuEdit);
		menuBar1.add(menuOptions);
		menuFile.add(menuFileNew);
		menuFile.add(menuFileOpen);
		menuFile.add(menuFileSave);
		menuFile.add(menuFileSaveAs);
		menuFile.add(menuFileSavePreviewBMP);
		menuFile.add(menuFileExit);
		menuEdit.add(menuEditCut);
		menuEdit.add(menuEditCopy);
		menuEdit.add(menuEditPaste);
		menuOptions.add(menuOptionsSinglePlayer);
		menuOptions.add(menuOptionsMultiPlayer);
		menuOptions.add(menuOptionsSeparator1);
		menuOptions.add(menuOptionsGameType);
		menuOptionsGameType.add(menuOptionsGameTypeCaptureAllPlanets);
		menuOptionsGameType.add(menuOptionsGameTypeCaptureAllStations);
		menuOptionsGameType.add(menuOptionsGameTypeRescueMission);
		menuOptionsGameType.add(menuOptionsGameTypeEscortMission);
		menuOptionsGameType.add(menuOptionsGameTypeSoccer);
		menuOptionsGameType.add(menuOptionsGameTypeHoldDowntheFort);
		add(mTypeChoice);
		add(mSpecificsChoice1);
		add(label1);
		add(label2);
		add(mPlayer0Label);
		add(mPlayer1Label);
		add(mPlayerChoice);
		add(mFilenameField);
		add(label3);
		add(label4);
		add(mPlanetNameField);
		add(mSubmitButton);
		add(mDistanceLabel);
		add(jTable1);
		add(jScrollPane1);
		add(mSpecialCheckbox);
		add(mNumTurnsText);
		add(label5);
		add(mTimePerTurnText);
		add(label6);
		add(mSpecialInsideCheckbox);

		setSize(new java.awt.Dimension(1100, 790));

		// event handling
		mTypeChoice.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				mTypeChoiceItemStateChanged(e);
			}
		});
		mSpecificsChoice1.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				mSpecificsChoice1ItemStateChanged(e);
			}
		});
		mPlayerChoice.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				mPlayerChoiceItemStateChanged(e);
			}
		});
		mFilenameField.addTextListener(new java.awt.event.TextListener() {
			public void textValueChanged(java.awt.event.TextEvent e) {
				mFilenameFieldTextValueChanged(e);
			}
		});
		mPlanetNameField.addTextListener(new java.awt.event.TextListener() {
			public void textValueChanged(java.awt.event.TextEvent e) {
				mPlanetNameFieldTextValueChanged(e);
			}
		});
		mSubmitButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				mSubmitButtonActionPerformed(e);
			}
		});
		jTable1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
			public void propertyChange(java.beans.PropertyChangeEvent e) {
				jTable1PropertyChange(e);
			}
		});
		jTable2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
			public void propertyChange(java.beans.PropertyChangeEvent e) {
				jTable2PropertyChange(e);
			}
		});
		menuFileNew.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuFileNewActionPerformed(e);
			}
		});
		menuFileOpen.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuFileOpenActionPerformed(e);
			}
		});
		menuFileSave.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuFileSaveActionPerformed(e);
			}
		});
		menuFileSaveAs.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuFileSaveAsActionPerformed(e);
			}
		});
		menuFileSavePreviewBMP.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuFileSavePreviewBMPActionPerformed(e);
			}
		});
		menuFileExit.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuFileExitActionPerformed(e);
			}
		});
		menuEditCut.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuEditCutActionPerformed(e);
			}
		});
		menuEditCopy.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuEditCopyActionPerformed(e);
			}
		});
		menuEditPaste.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuEditPasteActionPerformed(e);
			}
		});
		menuOptionsSinglePlayer.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				menuOptionsSinglePlayerItemStateChanged(e);
			}
		});
		menuOptionsMultiPlayer.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				menuOptionsMultiPlayerItemStateChanged(e);
			}
		});
		menuOptionsGameTypeCaptureAllPlanets.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				menuOptionsGameTypetemStateChanged(e);
			}
		});
		menuOptionsGameTypeCaptureAllStations.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				menuOptionsGameTypetemStateChanged(e);
			}
		});
		menuOptionsGameTypeRescueMission.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				menuOptionsGameTypetemStateChanged(e);
			}
		});
		menuOptionsGameTypeEscortMission.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				menuOptionsGameTypetemStateChanged(e);
			}
		});
		menuOptionsGameTypeSoccer.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				menuOptionsGameTypetemStateChanged(e);
			}
		});
		menuOptionsGameTypeHoldDowntheFort.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				menuOptionsGameTypetemStateChanged(e);
			}
		});
		mNumTurnsText.addTextListener(new java.awt.event.TextListener() {
			public void textValueChanged(java.awt.event.TextEvent e) {
				mNumTurnsTextTextValueChanged(e);
			}
		});
		mTimePerTurnText.addTextListener(new java.awt.event.TextListener() {
			public void textValueChanged(java.awt.event.TextEvent e) {
				mTimePerTurnTextTextValueChanged(e);
			}
		});
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				thisWindowClosing(e);
			}
		});

// END GENERATED CODE
		mCanvas = new smCanvas();
		mCanvas.setSize(mCanvas.mMaxWidth*mCanvas.mGridTileSize,mCanvas.mMaxHeight*mCanvas.mGridTileSize);
		mCanvas.setLocation(10,0);
		add(mCanvas);
		for(int i = 0; i < mCanvas.mTypeStrings.length; i++)
			mTypeChoice.add(mCanvas.mTypeStrings[i]);
		
		mPlayerChoice.add("PLAYER 0");
		mPlayerChoice.add("PLAYER 1");
		mPlayerChoice.add("NONE");
		mPlayerChoice.select(2);
		
		mCanvas.addMouseListener(this);	
		mCanvas.addMouseMotionListener(this);
		
		//add the scenario picker
		mPicker = new smPickerCanvas();
		mPicker.setSize((mPicker.mMaxWidth+1)*mPicker.mGridTileSize,(mPicker.mMaxHeight+1)*mPicker.mGridTileSize);
		mPicker.setLocation(810,0);
		
		//set the colors
		mCanvas.mPlayerColors[0] = mPicker.getPlayerColor(0);
		mCanvas.mPlayerColors[1] = mPicker.getPlayerColor(1);
		
		add(mPicker);
		
		mPicker.addMouseListener(this);	
		jTable1.hide();
	
		mPlayer0Label.setBackground(mPicker.getPlayerColor(0));
		mPlayer1Label.setBackground(mPicker.getPlayerColor(1));
		menuFileNew.setShortcut(new MenuShortcut(KeyEvent.VK_N));
		menuFileOpen.setShortcut(new MenuShortcut(KeyEvent.VK_O));
		menuFileSaveAs.setShortcut(new MenuShortcut(KeyEvent.VK_S,true));
		menuFileSave.setShortcut(new MenuShortcut(KeyEvent.VK_S));
		menuFileExit.setShortcut(new MenuShortcut(KeyEvent.VK_Q));
		menuEditCut.setShortcut(new MenuShortcut(KeyEvent.VK_X));
		menuEditCopy.setShortcut(new MenuShortcut(KeyEvent.VK_C));
		menuEditPaste.setShortcut(new MenuShortcut(KeyEvent.VK_V));
		setNew();
		
	}
  
  	private boolean mShown = false;
  	
	public void addNotify() {
		super.addNotify();
		
		if (mShown)
			return;
			
		// move components to account for insets
		Insets insets = getInsets();
		Component[] components = getComponents();
		for (int i = 0; i < components.length; i++) {
			Point location = components[i].getLocation();
			location.move(location.x, location.y + insets.top);
			components[i].setLocation(location);
		}
		mShown = true;
	}

	// Close the window when the close box is clicked
	void thisWindowClosing(java.awt.event.WindowEvent e) 
	{
		setVisible(false);
		//dispose();
		System.exit(0);
	}
	
	public void mTypeChoiceItemStateChanged(java.awt.event.ItemEvent e) 
	{
		int type = mTypeChoice.getSelectedIndex()+mCanvas.SPACE_UNIT_INDEX_OFFSET;
		if(mCanvas.isPlanet(type))
		{
			mSpecificsChoice1.enable();
			label2.setText("Number of Factories");
			mSpecificsChoice1.removeAll();
			for(int i = 0; i <9; i++)
				mSpecificsChoice1.add(""+i);
		
		}
		else if(mCanvas.isDecoy(type))
		{
			mSpecificsChoice1.enable();
			label2.setText("Decoy Type");
			mSpecificsChoice1.removeAll();
			for(int i = 0; i < mCanvas.mDecoyStrings.length; i++)
				mSpecificsChoice1.add(mCanvas.mDecoyStrings[i]);
		}
		else
		{
			label2.setText("");
			mSpecificsChoice1.removeAll();
			mSpecificsChoice1.disable();
		}
		if(mCanvas.isPlanet(type) || mCanvas.isCargoShip(type))
		{
			jTable1.show();
		}
		else
		{
			jTable1.editCellAt(-1,-1);
			//fill with zeros
			for(int i = 0; i < jTable1.getRowCount(); i++)
			{
				jTable1.setValueAt("0",i,1);
				jTable1.setValueAt("0",i,2);
			}
			jTable1.hide();
			this.repaint();
		}
		if(mTypeChoice.getSelectedIndex() == 0)
			mPlayerChoice.select(2);
	}
	public void mPlayerChoiceItemStateChanged(java.awt.event.ItemEvent e) 
	{
	}
	public void GuiToTile(int x, int y)
	{
		short type = (short)(mTypeChoice.getSelectedIndex());
		
		//set the special tag
		short special = (short)(mSpecialCheckbox.getState()?1:0);
		short specialInside = (short)(mSpecialInsideCheckbox.getState()?1:0);
		short specialValue = (short)(special | specialInside<<1);
		if(type != 0)
			type+= mCanvas.SPACE_UNIT_INDEX_OFFSET;
		short specifics = (short)(mSpecificsChoice1.getSelectedIndex());
		if(specifics == -1)
			specifics = 0;
		if(mCanvas.isDecoy(type))
		{
			specifics+= mCanvas.DECOY_TYPE_INDEX_OFFSET;
		}
		mCanvas.setTile(x,y,(short)mPlayerChoice.getSelectedIndex(),type,specifics, mFilenameField.getText(),mPlanetNameField.getText(),specialValue);
		GuiToSubUnits(x,y);
		mCanvas.paintTile(mCanvas.getGraphics(),x,y);
		mCanvas.paintSelected(mCanvas.getGraphics());
	}
	public void TileToGui(int x, int y)
	{
		int choiceIndex = mCanvas.mType[mCanvas.mSelectedIndex[0]][x][y];
		
		choiceIndex = choiceIndex == 0?0:choiceIndex-mCanvas.SPACE_UNIT_INDEX_OFFSET;
		mTypeChoice.select(choiceIndex);
		mTypeChoiceItemStateChanged(null);
		
		//set the checkbox for special
		int specialValue = mCanvas.mIsSpecial[mCanvas.mSelectedIndex[0]][x][y];
		mSpecialCheckbox.setState((specialValue & 1) > 0 ? true : false);
		mSpecialInsideCheckbox.setState((specialValue & 2) > 0 ? true : false);
		
		mPlayerChoice.select(mCanvas.mOwner[mCanvas.mSelectedIndex[0]][x][y]);
		if(mSpecificsChoice1.isEnabled())
		{
			if(mCanvas.isDecoy(choiceIndex + mCanvas.SPACE_UNIT_INDEX_OFFSET))
			{
				this.mSpecificsChoice1.select(mCanvas.mSpecific[mCanvas.mSelectedIndex[0]][x][y]-mCanvas.DECOY_TYPE_INDEX_OFFSET);
			}
			else
				this.mSpecificsChoice1.select(mCanvas.mSpecific[mCanvas.mSelectedIndex[0]][x][y]);
		}
		String planetName = ""+mCanvas.mPlanetNames[x][y];
		String fileName = ""+mCanvas.mPlanetFileNames[x][y];
		
		mPlanetNameField.setText(planetName);
		mFilenameField.setText(fileName);
		if(jTable1.isVisible())
			SubUnitsToGui(x,y);
	}
	public void GuiToSubUnits(int x, int y)
	{
		if(!jTable1.isVisible())
		{
			for(int i = 0; i < mCanvas.mSelectedIndex.length; i++)
				mCanvas.mSubUnits[mCanvas.mSelectedIndex[i]][x][y] = null;
			return;
		}
		jTable1.editCellAt(0,0);
		Vector v = new Vector();
		for(int i = 0; i < jTable1.getRowCount(); i++)
		{
			int num_units = Integer.parseInt((String)jTable1.getValueAt(i,1));
			if(num_units > 0)
			{
				for(int j = 0; j < num_units; j++)
				{
					short special = (short)Integer.parseInt((String)jTable1.getValueAt(i,2));
					subUnit u = new subUnit(i+1,100,special);
					v.add(u);
				}
			}
		}
		for(int i = 0; i < mCanvas.mSelectedIndex.length; i++)
			mCanvas.mSubUnits[mCanvas.mSelectedIndex[i]][x][y] = new Vector(v);
	}
	public void SubUnitsToGui(int x, int y)
	{
		jTable1.editCellAt(-1,-1);
		//fill with zeros
		for(int i = 0; i < jTable1.getRowCount(); i++)
		{
			jTable1.setValueAt("0",i,1);
			jTable1.setValueAt("0",i,2);
		}
		if(mCanvas.mSubUnits[mCanvas.mSelectedIndex[0]][x][y] != null)
		{
			Vector v = mCanvas.mSubUnits[mCanvas.mSelectedIndex[0]][x][y];
			Enumeration enum = v.elements();
			while(enum.hasMoreElements())
			{
				subUnit u = (subUnit)enum.nextElement();
				int val = Integer.parseInt((String)jTable1.getValueAt(u.id -1,1));
				val++;
				jTable1.setValueAt(""+val,u.id -1,1);
				jTable1.setValueAt(""+u.isSpecial,u.id -1,2);

			}
		
		}
	
	}
	
	

	public void mouseDragged(MouseEvent e) {;}
	public void mouseEntered(MouseEvent e) {;}
	public void mouseExited(MouseEvent e) {;}
	public void mousePressed(MouseEvent e) {;}
	public void mouseReleased(MouseEvent e) {;} 
	public void mouseClicked(MouseEvent e)
	{
		if(e.getComponent() == mCanvas)
		{
			int x = e.getX()/mCanvas.mGridTileSize;
			int y = e.getY()/mCanvas.mGridTileSize;
			if(x >= 0 && x < mCanvas.mMaxWidth && y >= 0 && y < mCanvas.mMaxHeight)
			{
				mCanvas.selectTile(x,y);
				TileToGui(x,y);			
			}
		}
		else //picker was clicked
		{
			int x = (e.getX()/mPicker.mGridTileSize)-1;
			int y = (e.getY()/mPicker.mGridTileSize)-1;
			if(x >= 0 && x < mPicker.mMaxWidth && y >= 0 && y < mPicker.mMaxHeight)
			{
				if(e.isShiftDown())
				{
					int temp[] =  mPicker.selectTileAdd(x,y);
					if(temp != null)
						mCanvas.mSelectedIndex = temp;
				}
				else
				{
					int index = mPicker.selectTile(x,y);
					if(index>=0)
					{
						mCanvas.mSelectedIndex = new int[1];
						mCanvas.mSelectedIndex[0] = index;
						mCanvas.mPlayerColors[0] = mPicker.getPlayerColor(0);
						mCanvas.mPlayerColors[1] = mPicker.getPlayerColor(1);
						
						mCanvas.paint(mCanvas.getGraphics());
						mPlayer0Label.setBackground(mPicker.getPlayerColor(0));
						mPlayer1Label.setBackground(mPicker.getPlayerColor(1));
						
						for(int i = 0; i < 5; i++)
						{
							jTable2.setValueAt(""+mCanvas.mPlayerResources[index][0][i],0,i+1);
							jTable2.setValueAt(""+mCanvas.mPlayerResources[index][1][i],1,i+1);
						}
						
					}
					
				}
				TileToGui(mCanvas.mSelectedX,mCanvas.mSelectedY);
				System.out.println("index ="+mCanvas.mSelectedIndex[0]);
				for(int i = 0; i < mCanvas.mSelectedIndex.length; i++)
					System.out.println("mSelectedIndex["+i+"]="+mCanvas.mSelectedIndex[i]);
			}
		}
		
	}
	public void mouseMoved(MouseEvent e) 
	{
		if(e.getComponent() == mCanvas)
		{
			int x = e.getX()/mCanvas.mGridTileSize;
			int y = e.getY()/mCanvas.mGridTileSize;
			if(x >= 0 && x < mCanvas.mMaxWidth && y >= 0 && y < mCanvas.mMaxHeight)
			{
				int dist = Math.abs(x - mCanvas.mSelectedX) + Math.abs(y - mCanvas.mSelectedY) ;
				mDistanceLabel.setText("Distance:"+dist);
			}
		}
	}
	public void mFilenameFieldTextValueChanged(java.awt.event.TextEvent e) 
	{
	}
	
	public void mPlanetNameFieldTextValueChanged(java.awt.event.TextEvent e) 
	{
	}
	
	public void mSpecificsChoice1ItemStateChanged(java.awt.event.ItemEvent e) {
	}
	
	public void mSubmitButtonActionPerformed(java.awt.event.ActionEvent e) 
	{
		GuiToTile(mCanvas.mSelectedX,mCanvas.mSelectedY);
		setDirty();
	}
	
	public void jTable2PropertyChange(java.beans.PropertyChangeEvent e) 
	{
		int index;
		for(int j = 0; j < 5; j++)
		{
			for(int i = 0; i < mCanvas.mSelectedIndex.length; i++)
			{
				index =  mCanvas.mSelectedIndex[i];
				mCanvas.mPlayerResources[index][0][j] = (short)(Integer.parseInt((String)(jTable2.getValueAt(0,j+1))));
				mCanvas.mPlayerResources[index][1][j] = (short)(Integer.parseInt((String)(jTable2.getValueAt(1,j+1))));
			}
		}
		setDirty();
		
	}
	
	public void menuFileSaveAsActionPerformed(java.awt.event.ActionEvent e) 
	{
		saveAsFile();
	}
	
	class smfFilter implements FilenameFilter
	{
		public boolean accept(File dir, String name) 
		{
			if(name.endsWith("smf"))
				return true;
			else
				return false;
		}
	}

	public void saveAsFile()
	{
		FileDialog d = new  FileDialog(this, "Save .ssf", FileDialog.SAVE);
		d.setFilenameFilter(new smfFilter());
		d.setFile("*.ssf");
		d.show();
		String fileName = d.getFile();
		if(fileName != null)
		{
			//do a little string manipulation to get the suffix
			// in and lower case
			if(fileName.toLowerCase().endsWith(".ssf"))
			{
				int index = fileName.lastIndexOf('.');
				String suffix = fileName.substring(index);
				suffix = suffix.toLowerCase();
				String prefix = fileName.substring(0,index);
				fileName = prefix+suffix;
			}
			else
			{
				fileName += ".ssf";
			}
			
			saveFile(d.getDirectory()+fileName);
		}
	}
	public void saveFile(String fileName)
	{
		//setStatus("saving "+fileName);
		try
		{
			//FileOutputStream fout = new FileOutputStream(fileName);
			//DataOutputStream out = new DataOutputStream(fout); 
			RandomAccessFile out = new RandomAccessFile(fileName,"rw");
			mCanvas.save(out);
			out.close();
			//fout.close();
			setClean(fileName);
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
			mOpenFileName = "";
			setNew();
		}	
		//setStatus(fileName+" saved");	
	}
	public void setClean(String fileName)
	{
		String s = fileName.substring(fileName.lastIndexOf('\\')+1);
		String title = "SpaceMap Helper:";
		title+=s;
		setTitle(title);
		mOpenFileName = fileName;
		mDirty = false;
		this.menuFileSave.disable();
	}
	public void setDirty()
	{
		if(!mDirty)
		{
			String title = this.getTitle();
			title+="*";
			setTitle(title);
			mDirty = true;
			this.menuFileSave.enable();

		}
	}
	public void setNew()
	{
		mOpenFileName = "";
		setTitle("SpaceMap Helper:");
		mDirty = false;
	}	
	
	public void menuFileOpenActionPerformed(java.awt.event.ActionEvent e) 
	{
		mCanvas.clear();

		FileDialog d = new  FileDialog(this, "Open an ssf file", FileDialog.LOAD);
		d.setFilenameFilter(new smfFilter());
		d.setFile("*.ssf");
		d.show();
		String fileName = d.getFile();
		if(fileName != null)
		{
			System.out.println("opening: "+d.getDirectory()+fileName);
			try
			{
				FileInputStream fin = new FileInputStream(d.getDirectory()+fileName);
				DataInputStream in = new DataInputStream(fin); 
				mCanvas.read(in);
				fin.close();
				mCanvas.repaint();
				this.TileToGui(mCanvas.mSelectedX,mCanvas.mSelectedY);
				repaint();
				setClean(d.getDirectory()+fileName);
				fixGameTypeMenus();
				fixNumPlayerMenus();
				fixTurnText();
				//reset the text fields
				
				//a bit of a hack we will disable these guys
				//so that they know to not "setDirty()"
				/*mWidthField.disable();
				mHeightField.disable();
				mXOffsetField.disable();
				mYOffsetField.disable();
				this.mPopulationFieldAgrressor.disable();
				this.mPopulationFieldDefender.disable();
				this.mExportPathTableCheckbox.disable();
				
				mWidthField.setText(""+mMapCanvas.mWidth);
				mHeightField.setText(""+mMapCanvas.mHeight);
				mXOffsetField.setText(""+mMapCanvas.mOffsetX);
				mYOffsetField.setText(""+mMapCanvas.mOffsetY);
				
				mPopulationFieldAgrressor.setText(""+mMapCanvas.mMaxTroopsAggressor);
				mPopulationFieldDefender.setText(""+mMapCanvas.mMaxTroopsDefender);
				
				mExportPathTableCheckbox.setState(mMapCanvas.mExportPaths);
				mExportPathTableCheckbox.enable();
				
				mPopulationFieldAgrressor.enable();
				mPopulationFieldDefender.enable();
				
				setClean(d.getDirectory()+fileName);*/
			}
			catch(Exception ex)
			{
				ex.printStackTrace();
			}
		}

	}
	
	public void menuFileNewActionPerformed(java.awt.event.ActionEvent e) 
	{
		mCanvas.clear();
		mCanvas.repaint();
		this.TileToGui(mCanvas.mSelectedX,mCanvas.mSelectedY);
		repaint();
		setNew();
		fixGameTypeMenus();
		fixNumPlayerMenus();
	}
	
	public void menuFileSaveActionPerformed(java.awt.event.ActionEvent e) 
	{
		this.saveFile(this.mOpenFileName);
	}
	
	public void jTable1PropertyChange(java.beans.PropertyChangeEvent e) 
	{
		
		short type = (short)(jTable1.getSelectedRow()+1);
		short parentType = mCanvas.mType[mCanvas.mSelectedIndex[0]][mCanvas.mSelectedX][mCanvas.mSelectedY];
		if(!validateUnit(type,parentType))
		{
			int row = jTable1.getSelectedRow();
			if(row >= 0 && row < jTable1.getRowCount())
				jTable1.setValueAt("0",row,1);
		}
	}
	public boolean validateUnit(short type,short parentType)
	{
		boolean isValid = false;
		
		if(mCanvas.raceArray[type] == -1)
			isValid = true;
		if(mCanvas.raceArray[parentType] == -1)
		{
			int owner = (int)mCanvas.mOwner[ mCanvas.mSelectedIndex[0]][ mCanvas.mSelectedX][ mCanvas.mSelectedY];
			if(owner == 2)
				isValid = false;
			else
				isValid = true;		
		}
		if(mCanvas.raceArray[type] == mCanvas.raceArray[parentType])
			isValid = true;
		switch(type)
		{
			case 1:
			case 5:
			case 7:
			case 20:
			case 21:
			case 22:
			case 23:
			
				isValid = false;
				break;
			default:
				break;
		}
		return isValid;		
	
	}									
	
	public void menuEditCopyActionPerformed(java.awt.event.ActionEvent e) 
	{
		mCanvas.copy();
	}
	
	public void menuEditPasteActionPerformed(java.awt.event.ActionEvent e) 
	{
		mCanvas.paste();
	}
	
	public void menuEditCutActionPerformed(java.awt.event.ActionEvent e) 
	{
		mCanvas.cut();
	}
	
		
	public void menuOptionsGameTypetemStateChanged(java.awt.event.ItemEvent e) 
	{
		System.out.println("action event:  "+e);
		CheckboxMenuItem selected = (CheckboxMenuItem)e.getSource();
		
		Menu parent = (Menu)selected.getParent();
		int index = 0;
		for(int i = 0; i < parent.getItemCount(); i++)
		{
			CheckboxMenuItem item = (CheckboxMenuItem)parent.getItem(i);
			if(item != selected)
				item.setState(false);
			else
				index = i;
		}
		selected.setState(true);
		if(mCanvas.mGameType != (byte)index)
		{
			mCanvas.mGameType = (byte)index;
			this.setDirty();
		}
	}
		
	public void fixGameTypeMenus()
	{
		Menu parent = menuOptionsGameType;
		for(int i = 0; i < parent.getItemCount(); i++)
		{
			CheckboxMenuItem item = (CheckboxMenuItem)parent.getItem(i);
			if(i != mCanvas.mGameType)
				item.setState(false);
			else
				item.setState(true);
		}
	}													
	public void fixNumPlayerMenus()
	{
		if(mCanvas.mNumPlayers == mCanvas.SINGLE_PLAYER)
		{
			menuOptionsSinglePlayer.setState(true);
			menuOptionsMultiPlayer.setState(false);
		}
		else
		{
			menuOptionsSinglePlayer.setState(false);
			menuOptionsMultiPlayer.setState(true);
		}
	
	}
	public void fixTurnText()
	{
		mNumTurnsText.setText(""+mCanvas.mNumTurns);
		mTimePerTurnText.setText(""+mCanvas.mTimePerTurn);
	}
	public void menuOptionsSinglePlayerItemStateChanged(java.awt.event.ItemEvent e) 
	{
		
		//if(!menuOptionsSinglePlayer.getState()) 
		{
			mCanvas.mNumPlayers = mCanvas.SINGLE_PLAYER;
			menuOptionsSinglePlayer.setState(true);
			menuOptionsMultiPlayer.setState(false);
		}
	}
	
	public void menuOptionsMultiPlayerItemStateChanged(java.awt.event.ItemEvent e) 
	{
		//if(!menuOptionsMultiPlayer.getState()) 
		{
			mCanvas.mNumPlayers = mCanvas.MULTI_PLAYER;
			menuOptionsMultiPlayer.setState(true);
			menuOptionsSinglePlayer.setState(false);
		}
	}
	
	public void mNumTurnsTextTextValueChanged(java.awt.event.TextEvent e) 
	{
		try
		{
			short numTurns = (short)Integer.parseInt(mNumTurnsText.getText());
			mCanvas.mNumTurns = numTurns;
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		
		}
	}
	
	public void mTimePerTurnTextTextValueChanged(java.awt.event.TextEvent e) 
	{
		try
		{
			short perTurn = (short)Integer.parseInt( mTimePerTurnText.getText());
			if(perTurn != mCanvas.mTimePerTurn)
			{
				mCanvas.mTimePerTurn = perTurn;
				setDirty();
			}  
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		
		}
	}
	
	public void menuFileExitActionPerformed(java.awt.event.ActionEvent e) 
	{
		this.thisWindowClosing(null);
	}
	
	public void menuFileSavePreviewBMPActionPerformed(java.awt.event.ActionEvent e) 
	{
		FileDialog d = new  FileDialog(this, "where's the bmp", FileDialog.SAVE);
		//d.setFilenameFilter(new smfFilter());
		String f;
		
		if(mOpenFileName.equals(""))
			f = "*.bmp";
		else
		{
			f = mOpenFileName.substring(mOpenFileName.lastIndexOf('\\')+1);
			f = f.substring(0,f.lastIndexOf(".ssf"));
			f = f+".bmp";
		}
		d.setFile(f);
		d.show();
		String fileName = d.getFile();
		if(fileName != null)
		{
			System.out.println("saving: "+d.getDirectory()+fileName);
			FileOutputStream fout = null;
			try
			{
				fout = new FileOutputStream(d.getDirectory()+fileName);
				DataOutputStream out = new DataOutputStream(fout); 
				mCanvas.exportBMP(out);
				fout.close();
			}
			catch(Exception ex)
			{
				ex.printStackTrace();
			}
				
			System.out.println("file saved");
		}
		
	}
	
}